using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace rsosp_Example
{
    public partial class rsosp_Example : Form
    {
        private RohdeSchwarz.RsOsp.Interop.IRsOsp m_Instrument = null;

        public rsosp_Example()
        {
            InitializeComponent();
        }
     
        private void ExitBTN_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void ApplyBTN_Click(object sender, EventArgs e)
        {
            try
            {
                UseWaitCursor = true;
                System.Windows.Forms.Cursor.Current = Cursors.WaitCursor;
                String catalog;
                String pathName = "examplePath";
                String chanList = "";

                m_Instrument = new RohdeSchwarz.RsOsp.Interop.RsOsp();
                m_Instrument.Initialize(ResourceDescriptor.Text, IDQuery.Checked, ResetDevice.Checked, "");

                catalog = m_Instrument.Module.Catalog;
                if (!catalog.Contains("B101-F01A11"))
                {
                    String message;

                    message = "Instrument Configuration Error: ";
                    message += "This example needs instrument F01 with module B101 in port A11!";
                    MessageBox.Show(message);
                }
                else
                {
                    /* Set Relay K11 */
                    if (k11_1.Checked)
                    {
                        chanList += "F01A11(0101),";
                    }
                    else
                    {
                        chanList += "F01A11(0001),";
                    }

                    /* Set Relay K12 */
                    if (k12_1.Checked)
                    {
                        chanList += "F01A11(0102),";
                    }
                    else
                    {
                        chanList += "F01A11(0002),";
                    }

                    /* Set Relay K13 */
                    if (k13_1.Checked)
                    {                      
                        chanList += "F01A11(0103),";
                    }
                    else
                    {
                        chanList += "F01A11(0003),";
                    }

                    /* Set Relay K14 */
                    if (k14_1.Checked)
                    {
                        chanList += "F01A11(0104),";
                    }
                    else
                    {
                        chanList += "F01A11(0004),";
                    }

                    /* Set Relay K15 */
                    if (k15_1.Checked)
                    {
                        chanList += "F01A11(0105),";
                    }
                    else
                    {
                        chanList += "F01A11(0005),";
                    }

                    /* Set Relay K16 */
                    if (k16_1.Checked)
                    {
                        chanList += "F01A11(0106)";
                    }
                    else
                    {
                        chanList += "F01A11(0006)";
                    }

                    m_Instrument.Path.SetPath(pathName, chanList);
                    m_Instrument.Path.ConnectPath(pathName);
                }
            }
            catch (Exception ex)
            {
                String message;

                message = "Instrument Status Error: ";
                message += ex.Message;
                MessageBox.Show(message);
            }
            System.Windows.Forms.Cursor.Current = Cursors.Arrow;
            UseWaitCursor = false;
        }
        
    }
}